<template>
  <div>
    <h1>Hangman</h1>
    <div class="alphabet">
        <Character v-for="char in alphabet" :key="char" :value="char" v-on:value="charClicked($event)"></Character>
    </div>

    <HangmanBody :state="errorCount"></HangmanBody>

    <div class="alphabet">
        <SolutionChar v-for="(char, index) in solution" :key="index" :expected="char" :valid="pressedChars.indexOf(char) >= 0"></SolutionChar>
    </div>
  </div>
</template>

<script>

import Character from './Character'
import HangmanBody from './HangmanBody'
import SolutionChar from './SolutionChar'

export default {
  components: {
   Character,
   HangmanBody,
   SolutionChar
  },
  data() {
      return {
          errorCount: 0,
          pressedChars: [],
          solution: 'hello',
          alphabet: ["a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"]
      }
  },
  methods: {
      charClicked(char){
          if(this.pressedChars.indexOf(char) < 0) {
              this.pressedChars.push(char);
              if(this.solution.indexOf(char) < 0){
                  this.errorCount++;
              }
          }
      }
  }
}
</script>

<style>
* {
    font-family: 'Rye', cursive;
}

.alphabet {
    display: flex
}

</style>
